<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <title>Shop</title>

    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css">
    <link rel="stylesheet" href="/static/css/styles.css">
    <link rel="stylesheet" href="https://code.jquery.com/ui/1.10.2/themes/smoothness/jquery-ui.css" />
    <script src="/static/js/service.js"></script>
    <script src="//code.jquery.com/jquery-1.10.2.js"></script>
    <script src="//code.jquery.com/ui/1.11.4/jquery-ui.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.3.1/js/bootstrap.min.js"></script>

</head>
<body>
    <nav class="navbar" style="height: 60px; padding: 0px; background-color:#66a3ff;">
        <div class="collapse navbar-collapse justify-content-between" style="text-align: center; display:block;" id="navbar">
            <a class="navbar-brand shop-header" href="">Admin`s page</a>
        </div>
    </nav>

    <nav id="sidebar">
        <div class="sidebar-header" style="padding: 20px 0px 0px 20px;">
            <a class="tablinks" onclick="openTab(event, 'categories')">Categories</a>
        </div>

        <div class="sidebar-header" style="padding: 20px 0px 0px 20px;">
            <a class="tablinks" onclick="openTab(event, 'products')">Products</a>
        </div>

        <div class="sidebar-header" style="padding: 20px 0px 20px 20px;">
            <a class="tablinks" onclick="openTab(event, 'shop')">Shop</a>
        </div>

        <div class="shop-text" style="text-align: center; margin-top: 20px;">
            <a href="\logout" >Logout</a>
        </div>
    </nav>

    <div class="navbar-default">

        <div id="categories" class="tabcontent">
            <div style="margin-left: 20px; margin-top: 20px; padding: 10px; background: #b3d1ff; float: left;">
                <div class="shop-path-text" style="text-align: center; margin-bottom: 15px;">Add new category</div>
                <div class="form-group">
                    <label style="margin-left: 10px;">Name</label>
                    <input class="form-control" type="text" placeholder="Name" id="newCategoryName" style="width: 200px; height: 40px; margin-left: 10px;">
                </div>
                <div class="form-group">
                    <label style="margin-left: 10px;">Parent</label>
                    <select class="form-control" id="newCategoryParent" style="width: 200px; height: 40px; margin-left: 10px;"></select>
                </div>
                <button class="btn btn-success" type="submit" style="margin-left: 10px; width: 120px;" id="newCategoryAdd">Add new</button>
            </div>
            <div style="margin-left: 20px; margin-top: 20px; padding: 10px; background: #b3d1ff; float: left;">
                <div class="shop-path-text" style="text-align: center; margin-bottom: 15px;">Update or remove category</div>
                <div class="form-group">
                    <label style="margin-left: 10px;">Current category</label>
                    <select class="form-control" id="curCategory" style="width: 200px; height: 40px; margin-left: 10px;"></select>
                </div>
                <div class="form-group">
                    <label style="margin-left: 10px;">Num</label>
                    <input class="form-control" type="text" placeholder="0" id="curCategoryNum" style="width: 200px; height: 40px; margin-left: 10px;" readonly>
                </div>
                <div class="form-group">
                    <label style="margin-left: 10px;">Name</label>
                    <input class="form-control" type="text" placeholder="Name" id="curCategoryName" style="width: 200px; height: 40px; margin-left: 10px;">
                </div>
                <button class="btn btn-warning" type="submit" style="margin-left: 10px; width: 120px;" id="curCategoryUpdate">Update</button>
                <button class="btn btn-danger" type="submit" style="margin-left: 10px; width: 120px;" id="curCategoryRemove">Remove</button>
            </div>
        </div>

        <div id="products" class="tabcontent" style="display: none;">
            <div style="margin-left: 20px; margin-top: 20px; padding: 10px; background: #b3d1ff; float: left;">
                <div class="shop-path-text" style="text-align: center; margin-bottom: 15px;">Add new product</div>
                <div style="float: left;">
                    <div class="form-group">
                        <label style="margin-left: 10px;">Name</label>
                        <input class="form-control" type="text" placeholder="Name" id="newProductName" style="width: 200px; height: 40px; margin-left: 10px;">
                    </div>
                    <div class="form-group">
                        <label style="margin-left: 10px;">Price</label>
                        <input class="form-control" type="text" placeholder="(integer or float)" id="newProductPrice" style="width: 200px; height: 40px; margin-left: 10px;">
                    </div>
                    <div class="form-group">
                        <label style="margin-left: 10px;">Installment plan</label>
                        <select class="form-control" id="newProductInstallmentPlan" style="width: 200px; height: 40px; margin-left: 10px;">
                            <option value="true">True</option>
                            <option value="false">False</option>
                        </select>
                    </div>
                    <div class="form-group">
                        <label style="margin-left: 10px;">Warranty period</label>
                        <input class="form-control" type="text" placeholder="(integer)" id="newProductWarrantyPeriod" style="width: 200px; height: 40px; margin-left: 10px;">
                    </div>
                </div>
                <div style="float: left;">
                    <div class="form-group">
                        <label style="margin-left: 10px;">Image</label>
                        <input class="form-control" type="text" placeholder="Image url" id="newProductImage" style="width: 200px; height: 40px; margin-left: 10px;">
                    </div>
                    <div class="form-group">
                        <label style="margin-left: 10px;">Description</label>
                        <textarea class="form-control" placeholder="Product description" id="newProductDescription" style="width: 200px; height: 128px; margin-left: 10px;"></textarea>
                    </div>
                    <div class="form-group">
                        <label style="margin-left: 10px;">Category</label>
                        <select class="form-control" id="newProductCategory" style="width: 200px; height: 40px; margin-left: 10px;"></select>
                    </div>
                    <button class="btn btn-success" type="submit" style="margin-left: 10px; width: 120px;" id="newProductAdd">Add new</button>
                </div>
            </div>
            <div style="margin-left: 20px; margin-top: 20px; padding: 10px; background: #b3d1ff; float: left;">
                <div class="shop-path-text" style="text-align: center; margin-bottom: 15px;">Update or remove product</div>
                <div style="float: left;">
                    <div class="form-group">
                        <label style="margin-left: 10px;">Current product</label>
                        <select class="form-control" id="curProduct" style="width: 200px; height: 40px; margin-left: 10px;"></select>
                    </div>
                    <div class="form-group">
                        <label style="margin-left: 10px;">Name</label>
                        <input class="form-control" type="text" placeholder="Name" id="curProductName" style="width: 200px; height: 40px; margin-left: 10px;">
                    </div>
                    <div class="form-group">
                        <label style="margin-left: 10px;">Price</label>
                        <input class="form-control" type="text" placeholder="(integer of float)" id="curProductPrice" style="width: 200px; height: 40px; margin-left: 10px;">
                    </div>
                    <div class="form-group">
                        <label style="margin-left: 10px;">Installment plan</label>
                        <select class="form-control" id="curProductInstallmentPlan" style="width: 200px; height: 40px; margin-left: 10px;">
                            <option value="true">True</option>
                            <option value="false">False</option>
                        </select>
                    </div>
                    <div class="form-group">
                        <label style="margin-left: 10px;">Warranty period</label>
                        <input class="form-control" type="text" placeholder="(integer)" id="curProductWarrantyPeriod" style="width: 200px; height: 40px; margin-left: 10px;">
                    </div>
                </div>
                <div style="float: left;">
                    <div class="form-group">
                        <label style="margin-left: 10px;">Image</label>
                        <input class="form-control" type="text" placeholder="Image url" id="curProductImage" style="width: 200px; height: 40px; margin-left: 10px;">
                    </div>
                    <div class="form-group">
                        <label style="margin-left: 10px;">Description</label>
                        <textarea class="form-control" placeholder="Product description" id="curProductDescription" style="width: 200px; height: 128px; margin-left: 10px;"></textarea>
                    </div>
                    <div class="form-group">
                        <label style="margin-left: 10px;">Category</label>
                        <select class="form-control" id="curProductCategory" style="width: 200px; height: 40px; margin-left: 10px;"></select>
                    </div>
                    <button class="btn btn-warning" type="submit" style="margin-left: 10px; width: 120px;" id="curProductUpdate">Update</button>
                    <button class="btn btn-danger" type="submit" style="margin-left: 10px; width: 120px;" id="curProductRemove">Remove</button>
                </div>
            </div>
        </div>

        <div id="shop" class="tabcontent" style="display: none;">
            <div style="margin-left: 20px; margin-top: 20px; padding: 10px; background: #b3d1ff; float: left;">
                <div class="shop-path-text" style="text-align: center; margin-bottom: 15px;">Update shop info</div>
                <div class="form-group">
                    <label style="margin-left: 10px;">Name</label>
                    <input class="form-control" type="text" placeholder="Shop" id="shopName" style="width: 200px; height: 40px; margin-left: 10px;">
                </div>
                <div class="form-group">
                    <label style="margin-left: 10px;">Phone</label>
                    <input class="form-control" type="text" placeholder="8(800)553535" id="shopPhone" style="width: 200px; height: 40px; margin-left: 10px;">
                </div>
                <div class="form-group">
                    <label style="margin-left: 10px;">Address</label>
                    <input class="form-control" type="text" placeholder="Pirogova 14" id="shopAddress" style="width: 200px; height: 40px; margin-left: 10px;">
                </div>
                <button class="btn btn-warning" type="submit" style="margin-left: 10px; width: 120px;" id="shopUpdate">Update</button>
            </div>
        </div>

    </div>

<script>

    var nodeCategories = JSON.parse('{{node_categories | safe}}')
    var leafCategories = JSON.parse('{{leaf_categories | safe}}')
    var categories = JSON.parse('{{categories | safe}}')
    var products = JSON.parse('{{products | safe}}')
    var shopInfo = JSON.parse('{{shop_info | safe}}')


    $('#curCategory').on('change', function() {
        cat = getById(categories, this.options[this.selectedIndex].value)
        $('#curCategoryName').val(cat["name"])
        $('#curCategoryNum').val(cat["id"])
    })

    $('#curProduct').on('change', function() {
        pr = getById(products, this.options[this.selectedIndex].value)
        $('#curProductName').val(pr["name"])
        $('#curProductPrice').val(pr["price"])
        $('#curProductInstallmentPlan').val("" + pr["installment_plan"])
        $('#curProductWarrantyPeriod').val(pr["warranty_period"])
        $('#curProductImage').val(pr["img_url"])
        $('#curProductDescription').val(pr["description"])
        $('#curProductCategory').val(pr["cat_num"])
    })

    $('#newCategoryAdd').on('click', function() {
        console.log("Add category")
        var xhr = sendRequest("POST", "/category?id=-1&name=" + $('#newCategoryName').val() +
                                      "&parent=" + $('#newCategoryParent').val(),
                                      function(){
            var json = JSON.parse(xhr.responseText)
            nodeCategories = json["node_categories"]
            leafCategories = json["leaf_categories"]
            categories = nodeCategories.concat(leafCategories)
            fillSelect('newCategoryParent', nodeCategories)
            fillSelect('curCategory', categories)
            fillSelect('newProductCategory', leafCategories)
            fillSelect('curProductCategory', leafCategories)
        })
        $('#newCategoryName').val("")
    })

    $('#curCategoryUpdate').on('click', function() {
        console.log("Update category")
        var xhr = sendRequest("POST", "/category?id=" + $('#curCategoryNum').val() +
                                      "&name=" + $('#curCategoryName').val(),
                                      function(){
            var json = JSON.parse(xhr.responseText)
            nodeCategories = json["node_categories"]
            leafCategories = json["leaf_categories"]
            categories = nodeCategories.concat(leafCategories)
            fillSelect('newCategoryParent', nodeCategories)
            fillSelect('curCategory', categories)
            fillSelect('newProductCategory', leafCategories)
            fillSelect('curProductCategory', leafCategories)
        })
    })

    $('#curCategoryRemove').on('click', function() {
        console.log("Remove category")
        var xhr = sendRequest("DELETE", "/category?id=" + $('#curCategoryNum').val(), function(){
            var json = JSON.parse(xhr.responseText)
            nodeCategories = json["node_categories"]
            leafCategories = json["leaf_categories"]
            categories = nodeCategories.concat(leafCategories)
            fillSelect('newCategoryParent', nodeCategories)
            fillSelect('curCategory', categories)
            fillSelect('newProductCategory', leafCategories)
            fillSelect('curProductCategory', leafCategories)
        })
    })

    $('#newProductAdd').on('click', function() {
        console.log("Add product")
        var xhr = sendRequest("POST", "/product?id=-1&name=" + $('#newProductName').val() +
                                      "&price=" + $('#newProductPrice').val() +
                                      "&image=" + $('#newProductImage').val() +
                                      "&desc=" + $('#newProductDescription').val() +
                                      "&period=" + $('#newProductWarrantyPeriod').val() +
                                      "&plan=" + ($('#newProductInstallmentPlan').val() == 'true') +
                                      "&num=" + $('#newProductCategory').val(),
                                      function(){
            var json = JSON.parse(xhr.responseText)
            products = json["products"]
            fillSelect('curProduct', products)
        })
        $('#newProductName').val("")
        $('#newProductPrice').val("")
        $('#newProductImage').val("")
        $('#newProductDescription').val("")
        $('#newProductWarrantyPeriod').val("")
    })

    $('#curProductUpdate').on('click', function() {
        console.log("Update product")
        var xhr = sendRequest("POST", "/product?id=" + $('#curProduct').val() +
                                      "&name=" + $('#curProductName').val() +
                                      "&price=" + $('#curProductPrice').val() +
                                      "&image=" + $('#curProductImage').val() +
                                      "&desc=" + $('#curProductDescription').val() +
                                      "&period=" + $('#curProductWarrantyPeriod').val() +
                                      "&plan=" + ($('#curProductInstallmentPlan').val() == 'true') +
                                      "&num=" + $('#curProductCategory').val(),
                                      function(){
            var json = JSON.parse(xhr.responseText)
            products = json["products"]
            fillSelect('curProduct', products)
        })
    })

    $('#curProductRemove').on('click', function() {
        console.log("Remove product")
        var xhr = sendRequest("DELETE", "/product?id=" + $('#curProduct').val(), function() {
            var json = JSON.parse(xhr.responseText)
            products = json["products"]
            fillSelect('curProduct', products)
        })
    })

    $('#shopUpdate').on('click', function() {
        console.log("Update shop")
        var xhr = sendRequest("POST", "/shop?name=" + $('#shopName').val() +
                                      "&phone=" + $('#shopPhone').val() +
                                      "&address=" + $('#shopAddress').val(),
                                      function() {
            var json = JSON.parse(xhr.responseText)
            shopInfo = json["shop_info"]
            $('#shopName').val(shopInfo["name"])
            $('#shopPhone').val(shopInfo["phone"])
            $('#shopAddress').val(shopInfo["address"])
        })
    })

    fillSelect('newCategoryParent', nodeCategories)
    fillSelect('curCategory', categories)
    fillSelect('newProductCategory', leafCategories)
    fillSelect('curProductCategory', leafCategories)
    fillSelect('curProduct', products)
    $('#shopName').val(shopInfo["name"])
    $('#shopPhone').val(shopInfo["phone"])
    $('#shopAddress').val(shopInfo["address"])
</script>
</body>
</html>